###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2009 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildlargesmp 1
%define buildhugemem 1
%define buildxen 1
%define kernel_version 2.6.9-89.EL
%define subversion 56
 
%ifnarch i686 x86_64
%define buildsmp 0
%define buildxen 0
%endif

%ifnarch i686
%define buildhugemem 0
%endif

%ifnarch x86_64 ia64 ppc64
%define buildlargesmp 0
%endif

Name: cman-kernel
Version: 2.6.9
Release: %{subversion}.7%{?dist}.3
License: GPL
Group: System Environment/Kernel
Summary: cman-kernel - The Cluster Manager kernel modules
BuildRequires: kernel-devel = %{kernel_version}

%if %{buildsmp}
BuildRequires: kernel-smp-devel = %{kernel_version}
%endif

%if %{buildhugemem}
BuildRequires: kernel-hugemem-devel = %{kernel_version}
%endif

%if %{buildlargesmp}
BuildRequires: kernel-largesmp-devel = %{kernel_version}
%endif

%if %{buildxen}
BuildRequires: kernel-xenU-devel = %{kernel_version}
%endif

Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-modules-smp GFS-modules-hugemem
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: %{name}-%{version}-%{subversion}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
cman-kernel - The Cluster Manager kernel modules

%package -n cman-kernheaders
Group: Development/System
Summary: cman kernel header files

%description -n cman-kernheaders
The cman kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n cman-kernel-smp
Group: System Environment/Kernel
Summary: cman-kernel-smp - The Cluster Manager kernel smp modules
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}
%description -n cman-kernel-smp
cman-kernel-smp - The Cluster Manager kernel smp modules
%endif

%if %{buildhugemem}
%package -n cman-kernel-hugemem
Group: System Environment/Kernel
Summary: cman-kernel - The Cluster Manager kernel hugemem modules
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}

%description -n cman-kernel-hugemem
cman-kernel-hugemem - The Cluster Manager kernel hugemem modules
%endif

%if %{buildlargesmp}
%package -n cman-kernel-largesmp
Group: System Environment/Kernel
Summary: cman-kernel - The Cluster Manager kernel largesmp modules
Requires: kernel-largesmp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}largesmp
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}

%description -n cman-kernel-largesmp
cman-kernel-largesmp - The Cluster Manager kernel largesmp modules
%endif

%if %{buildxen}
%package -n cman-kernel-xenU
Group: System Environment/Kernel
Summary: cman-kernel - The Cluster Manager kernel xenU modules
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}

%description -n cman-kernel-xenU
cman-kernel-xenU - The Cluster Manager kernel xenU modules
%endif


################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
# Put the version information into the necessary files
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
      src/cnxman.c 

################################################################################
##  THE BUILD SECTION
################################################################################
%build

BUILD_DIR=`pwd`
ROOT_DIR_FILES=`ls`

mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem
cp -r up largesmp
cp -r up xenU

Build_cman(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	make
	$kernel_src/scripts/mod/modpost -m -i $kernel_src/Module.symvers src/cman.o -o cman.symvers
}



%if %{buildup}
cd up
Build_cman %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_cman %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_cman %{_target_cpu} hugemem
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
Build_cman %{_target_cpu} largesmp
cd ..
%endif

%if %{buildxen}
cd xenU
Build_cman %{_target_cpu} xenU
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
cd ..
%endif

%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}hugemem/kernel/cluster/
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}largesmp/kernel/cluster/
cd ..
%endif

%if %{buildxen}
cd xenU
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xenU/kernel/cluster/
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%if %{buildlargesmp}
%post largesmp
/sbin/depmod -e %{kernel_version}largesmp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%endif

%files
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}/kernel/cluster
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n cman-kernel-smp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}smp/kernel/cluster
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildhugemem}
%files -n cman-kernel-hugemem
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}hugemem/kernel/cluster
/lib/modules/%{kernel_version}hugemem/kernel/cluster/*
%endif %{buildhugemem}

%if %{buildlargesmp}
%files -n cman-kernel-largesmp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}largesmp/kernel/cluster
/lib/modules/%{kernel_version}largesmp/kernel/cluster/*
%endif %{buildlargesmp}

%if %{buildxen}
%files -n cman-kernel-xenU
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xenU/kernel/cluster
/lib/modules/%{kernel_version}xenU/kernel/cluster/*
%endif %{buildxen}

%files -n cman-kernheaders
%defattr(-,root,root,-)
%dir %{_includedir}/cluster
%{_includedir}/cluster/*

%changelog
* Tue Aug 11 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.7.EL
- Resolves: rhbz#516925

* Wed Jul 08 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.3.EL
- Resolves: rhbz#510075

* Tue May 05 2009 Chris Feist <cfeist@redhat.com>
- Built for kernel-2.6.9-89.EL

* Mon Dec 08 2008 Chris Feist <cfeist@redhat.com>
- Every 100 Hello messages now require an ACK, which will prevent comparisons
  from failing if no cman messages have been sent for awhile.

* Wed Nov 14 2007 Chris Feist <cfeist@redhat.com>
- Fixed a bug which would cause cman to throw away valid messages
- Resolves: rhbz#373671

* Thu Nov 08 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-67.EL kernel

* Tue Oct 02 2007 Chris Feist <cfeist@redhat.com>
- Fixed a NULL pointer dereference.
- Resolves: rhbz#199433

* Mon Oct 01 2007 Chris Feist <cfeist@redhat.com>
- Add a check to the use of "node" before calling start_transition.
- A check for a null messages was added to prevent a kernel oops.
- Resolves: rhbz#233521 rhbz#199433

* Mon Aug 20 2007 Chris Feist <cfeist@redhat.com>
- Disable xen until kernel is fixed

* Fri Aug 17 2007 Chris Feist <cfeist@redhat.com>
- Panic in start_transition fixed.
- Built for 2.6.9-56.EL kernel.
- Resolves: rhbz#233521

* Fri Jan 12 2007 Chris Feist <cfeist@redhat.com>
- Build for xenU kernel.

* Wed Dec 20 2006 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-42.0.4.EL kernel

* Fri Apr 21 2006 Chris Feist <cfeist@redhat.com>
- Added support for largesmp kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provide cman-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriptlet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up .spec file.

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel and upstream fixes

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel and upstream fixes

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Oct 22 2004 <cfeist@redhat.com>
- Various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- New install requirements

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- smp modules were being built, but not packaged
- specify more potential conflicts

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- Various bug fixes (new upstream sources)

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- bump rev # and build for i686 as well

* Mon Jul 13 2004 Jon Brassow <jbrassow@redhat.com> 
- bump rev # and build to proper place

* Mon Jul 13 2004 Jon Brassow <jbrassow@redhat.com> 
- Update for new upstream sources.

* Mon Jul 12 2004 Jon Brassow <jbrassow@redhat.com> 
- Update for new upstream sources.

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
